#!/usr/bin/env bash
# This script is used to build all sets of config options

set -e

if [ $# -eq 0 ]; then 
    echo "$0 [GCC4x] [Platform name]"
    exit 1
fi

FLAVOUR=([0]='PLAIN' [1]='SECURE')
ARG=(    [0]=''      [1]='-DSECURE_LD')

set -x
for num in 0 1; do
    ./quarkbuild.sh -d32 $@ ${ARG[$num]}
    ./quarkbuild.sh -r32 $@ ${ARG[$num]}
    (
        set -e
        cd Build/*Platform/
        mkdir  ${FLAVOUR[$num]}/
        ln -s RELEASE_GCC* RELEASE_GCC
        ln -s DEBUG_GCC* DEBUG_GCC
        mv RELEASE_GCC* DEBUG_GCC* ${FLAVOUR[$num]}/
    )
done

